<?php
if (!defined('BASEPATH'))
	exit('No direct script access allowed');
class User extends CI_Controller {
	public function __construct() {
		parent::__construct();
		$this -> load -> model('user_model');
		$this -> load -> model('main_model');
		$this -> load -> model('posts_model');

		//UpdateUserlastVisit();
		$this -> CheckLoginUser();
		$this -> CheckMaintenanceMode();

	}

	public function CheckMaintenanceMode() {

		$url_mthod = $this -> router -> fetch_method();

		if ($url_mthod == "MaintenanceMode")
			return true;

		$settingdata = getSettingdata();
		if ($settingdata -> maintenance_mode == 1) {
			set_user_msg(1, "الموقع فى وضع  الصيانة ");
			redirect('pages/MaintenanceMode');

		}
	}

	private function CheckLoginUser() {
		if (check_Front_logedin() == false) {
			$cMethod = $this -> router -> fetch_method();
			$funcs = array("login", "register", "forgetpass", "register_submit", 'login_submit', 'forgetpass_submit','verifyemail');
			if (in_array($cMethod, $funcs))
				return true;

			set_user_msg(2, "  الرجاء تسجيل الدخول اولا");
			redirect("user/login");
		}
	}

	public function index() {
		if (check_Front_logedin() == true) {
			$this -> welcome();
		} else {
			$this -> login();

		}
	}

	private function AddReplyToMessage() {

		if (isset($_POST['content']) != "" && trim($_POST['content']) != "" && $_POST['parent_id'] > 0) {

			$userID = get_Front_logedin_id();
			$postForm = $this -> input -> post();
			$postForm['created'] = date('Y-m-d H:i:s');
			$postForm['sender_id'] = $userID;
			unset($postForm['action']);
			$this -> main_model -> insert('messages', $postForm);
			set_user_msg(1, " تم  الاضافة بنجاح");

		}

	}

	public function MessageDetails($msgID = 0) {

		$this -> AddReplyToMessage();

		$data['title'] = '';
		$data['messageID'] = $msgID;
		$data['messages'] = $this -> posts_model -> GetRepliesOfMessage($msgID);

		$data['ContentCenter'] = $this -> load -> view('site/user_messageDetails', $data, true);
		//$data['most_rate'] = $this -> posts_model -> GetMostRatedPosts();
		$this -> load -> view('site/main', $data);

	}

	public function mymessages() {

		$data['title'] = '';
		$userID = get_Front_logedin_id();
		$data['messages'] = $this -> posts_model -> GetMessagesOfUser($userID);
		$data['ContentCenter'] = $this -> load -> view('site/user_mymessages', $data, true);
		//$data['most_rate'] = $this -> posts_model -> GetMostRatedPosts();
		$this -> load -> view('site/main', $data);

	}

	public function notifications() {

		$data['title'] = '';
		$userID = get_Front_logedin_id();
		$data['notifications'] = $this -> posts_model -> GetNotificationsOfUser($userID);
		$data['ContentCenter'] = $this -> load -> view('site/user_notification', $data, true);
		//$data['most_rate'] = $this -> posts_model -> GetMostRatedPosts();
		$this -> load -> view('site/main', $data);

	}

	public function myposts() {

		$data['title'] = '';
		$userID = get_Front_logedin_id();
		$data['posts'] = $this -> posts_model -> GetPostsOfUser($userID);
		$data['ContentCenter'] = $this -> load -> view('site/user_myposts', $data, true);
		//$data['most_rate'] = $this -> posts_model -> GetMostRatedPosts();
		$this -> load -> view('site/main', $data);

	}

	public function sendpm_submit() {

		if (trim($_POST['title']) != "" && trim($_POST['content']) != "") {

			$userID = get_Front_logedin_id();
			$postForm = $this -> input -> post();
			$postForm['created'] = date('Y-m-d H:i:s');
			$postForm['sender_id'] = $userID;
			unset($postForm['action']);
			$this -> main_model -> insert('messages', $postForm);
			set_user_msg(1, " تم التحديث بنجاح");
			redirect("user/mymessages");

		} else {
			set_user_msg(2, " للاسف لم يتم الإرسال");
			$this -> sendpm();
		}

	}

	public function addmessage() {

		$data['title'] = '';
		$data['ContentCenter'] = $this -> load -> view('site/user_sendpm', $data, true);
		//$data['most_rate'] = $this -> posts_model -> GetMostRatedPosts();
		$this -> load -> view('site/main', $data);

	}

	public function addpost() {

		$data['title'] = '';
		$data['ContentCenter'] = $this -> load -> view('site/user_addpost', $data, true);
		//$data['most_rate'] = $this -> posts_model -> GetMostRatedPosts();
		$this -> load -> view('site/main', $data);

	}

	public function CheckVIPSubscribeSubmit() {

		if (isset($_POST['action']) && $_POST['action'] == "VIPSbMtFrM") {
			$userID = get_Front_logedin_id();
			$postForm = $this -> input -> post();
			$postForm['created'] = date('Y-m-d H:i:s');
			$postForm['user_id'] = $userID;
			unset($postForm['action']);
			$this -> main_model -> insert('vip_requests', $postForm);
			set_user_msg(1, " تم  الإرسال  الى الادارة بنجاح وسيتم الترقية باقرب وقت");
		}
	}

	public function VIPsubscribe() {
		$this -> CheckVIPSubscribeSubmit();
		$data['title'] = '';
		$data['ContentCenter'] = $this -> load -> view('site/user_VIPsubscribe', $data, true);
		//$data['most_rate'] = $this -> posts_model -> GetMostRatedPosts();
		$this -> load -> view('site/main', $data);

	}

	public function addpaymentsubmit() {

		$userID = get_Front_logedin_id();
		$postForm = $this -> input -> post();
		$postForm['date_time'] = date('Y-m-d H:i:s');
		$postForm['user_id'] = $userID;

		$uploadedFileName = upload_file("imageFile", 'third_party/uploads/banktransfer/');
		if ($uploadedFileName != false) {
			$postForm['image'] = $uploadedFileName;
		} else {
			$postForm['image'] = "";
		}
		unset($postForm['imageFile']);

		$bank_transfersID = $this -> main_model -> insert('bank_transfers', $postForm);

		if ($bank_transfersID) {

			set_user_msg(1, "  تم الإرسال بنجاح وسيتم إرسال الرسائل للجوال باقرب وقت");
		} else {
			set_user_msg(2, "  للاسف لم يتم الاضافة الرجاء المحاولة مرة اخرى");
		}
		redirect("user/addpayment");

	}

	public function addpayment() {
		//$this -> CheckVIPSubscribeSubmit();
		$data['title'] = '';
		$data['ContentCenter'] = $this -> load -> view('site/user_addpayment', $data, true);
		//$data['most_rate'] = $this -> posts_model -> GetMostRatedPosts();
		$this -> load -> view('site/main', $data);

	}

	public function addpost_submit() {

		if (trim($_POST['title']) != "" && trim($_POST['description']) != "") {

			$userID = get_Front_logedin_id();
			$postForm = $this -> input -> post();
			$postForm['date_time'] = date('Y-m-d H:i:s');
			$postForm['owner_id'] = $userID;
			$postForm['enabled'] =                      getSettingdata() -> auto_approve_posts;

			unset($postForm['action']);

			$uploadedFileName = upload_file("imageFile", 'third_party/uploads/monasbat/');
			if ($uploadedFileName != false) {
				$postForm['image'] = $uploadedFileName;
			} else {
				$postForm['image'] = "";
			}
			unset($postForm['imageFile']);

			$packageID = $postForm['sms_package_id'];
			unset($postForm['sms_package_id']);
			$this -> main_model -> insert('monasbat_list', $postForm);

			if ($packageID > 0) {

				$arrSMS = array();
				$arrSMS['user_id'] = $userID;
				$arrSMS['message'] = $postForm['description'];
				$arrSMS['date_time'] = date('Y-m-d H:i:s');
				$arrSMS['package_id'] = $packageID;
				$arrSMS['sent'] = 0;
				$this -> main_model -> insert('sms_requests', $arrSMS);

				set_user_msg(1, "  تم الاضافة  بنجاح الرجاء الدفع ليتم إرسالة رسائل الجوال");
				redirect("user/addpayment");
			} else {
				set_user_msg(1, " تم الاضافة  بنجاح");
				redirect("user/myposts");
			}

		} else {
			set_user_msg(2, " للاسف لم يتم الإرسال");
			$this -> addpost();
		}

	}

	public function register() {
		// if (($this -> session -> userdata('front_uid') != ""))
		//   redirect(site_url("user/index"));

		/*$data['title'] = 'Register';
		 $data['form_action'] = site_url("user/register_submit");
		 $data['inner_content'] = $this -> load -> view('site/user_register', $data, true);
		 $data['ContentCenter'] = $this -> load -> view('site/inner_content_center', $data, true);
		 $this -> load -> view('site/main', $data);*/

		$data['title'] = '';
		$data['ContentCenter'] = $this -> load -> view('site/user_register', $data, true);
		//$data['most_rate'] = $this -> posts_model -> GetMostRatedPosts();
		$this -> load -> view('site/main', $data);

	}

	public function verifyemail($token = "xx") {
	

		$userData = getTableDataRowFields("users", " user_id ", array("token" => $token));
		if ($userData) {
			$userId = $userData -> user_id;
			$this -> user_model -> verifiyUser($userId);
			set_user_msg(1, "  تم تفعيل الإيميل بنجاح يمكنك الدخول الان ");
			

		} else {
			set_user_msg(2, " البيانات المدخلة غير صحيحة الرجاء المحاولة مرة اخرى ");
			
		}

		redirect(site_url("user/login"));

	}

	public function forgetpass_submit() {

		$this -> load -> library('form_validation');
		// field name, error message, validation rules
		//$this -> form_validation -> set_rules('username', 'Username', 'trim|required|is_unique[users.username]');
		$this -> form_validation -> set_rules('email', ' الإيميل غير صحيح', 'trim|required|valid_email');

		if ($this -> form_validation -> run() == FALSE) {
			$this -> forgetpass();
		} else {

			$email = $this -> input -> post("email");
			$userExists = getTableDataRowFields("users", "user_id", array("email" => $email));

			if ($userExists == false) {
				//-email not exists
				set_user_msg(2, " الإيميل غير موجود ");

				$this -> forgetpass();
			} else {

				$siteSettingsData = getTableDataRow("settings", array("id" => 1));
				$from_mail = $siteSettingsData -> email;

				$paswsword = $this -> user_model -> update_user_password($email);

				//$paswsword = getTableDataRowFields("users", "password", array("email" => $email));
				if ($paswsword) {

					//$paswsword = $paswsword -> password;
					set_user_msg(1, "تم إرسال كلمة المرور الى الإيميل ");

					$message = " كلمة المرور الخاصة بك  ($paswsword)";
					sendEmailToUser(" استعادة كلمة المرور ", $message, $email, $from_mail);
					ob_end_clean();
				}

				$this -> login();

			}

		}

	}

	public function register_submit() {
		/*echo "<pre>";
		 print_r($_POST);
		 die;*/

		$this -> load -> library('form_validation');
		// field name, error message, validation rules
		$this -> form_validation -> set_rules('user_name', 'اسم المستخدم', 'trim|required|is_unique[users.user_name]');
		$this -> form_validation -> set_rules('full_name', 'الرجاء ادخال الاسم كاملا', 'trim|required|min_length[4]');

		$this -> form_validation -> set_rules('city', ' المدينة', 'trim|required|min_length[4]');
		$this -> form_validation -> set_rules('birth_date', '  تاريخ الميلاد', 'trim|required|min_length[8]');
		$this -> form_validation -> set_rules('phone', '    رقم الجوال', 'trim|required|is_unique[users.phone]');
		$this -> form_validation -> set_rules('email', '  البريد   الالكترونى', 'trim|required|valid_email|is_unique[users.email]');
		$this -> form_validation -> set_rules('password', 'كلمة المرور', 'trim|required|min_length[6]|max_length[32]');
		$this -> form_validation -> set_rules('password_confirm', 'تأكيد كلمة المرور', 'trim|required|matches[password]');
		//	$this -> form_validation -> set_message('is_unique', "  اسم المستخدم  مسجل بالفعل");
		$this -> form_validation -> set_message('is_unique', ' %s   مسجل بالفعل');
		$this -> form_validation -> set_message('min_length', '%s:  اقل عدد من الحروف هو  %s');

		$this -> form_validation -> set_message('required', ' %s   الرجاء ادخال ');
		$this -> form_validation -> set_message('matches', 'كلمات المرور غير متطابقة');

		if ($this -> form_validation -> run() == FALSE) {
			$this -> register();
		} else {

			$token = $this -> user_model -> add_user();

			$name = $this -> input -> post("full_name");
			//$message_to_admin = "new User  $name Is Registered In Send SMS Site ";
			//sendEmailToadmin("SMS New User registeration ", $message_to_admin);
			///------send verification code to user by email
			$userEmil = $this -> input -> post("email");
			/***************/
			$password = $this -> input -> post('password');
			$this->QuizUserRelate($userEmil, $password,$name);
			
			/********************/
			//ob_end_clean();
			$this -> sendVerificationCodeTouser($token, $userEmil, $name);
			set_user_msg(1, "تم انشاء الحساب بنجاح الرجاء تفعيل البريد الالكترونى");
			//set_user_msg(1, "تم انشاء الحساب بنجاح  ");
			ob_end_clean();
			//$this -> login();
			redirect(site_url("pages/index"));

		}
	}

	public function sendVerificationCodeTouser($token, $userEmil, $name) {
		$siteSettingsData = getTableDataRow("settings", array("id" => 1));

		//$emailContent = $siteSettingsData -> verification_content;
		//-click on <a href='" . $verifyUrl . "'> Verify Email </a> \r\n
		$verifyUrl = site_url("user/verifyemail/$token");

		$subject = "  تفعيل حساب موقع مهارات وقدرات   ";

		//	$emailContent = str_replace("[[username]]", $name, $emailContent);
		//	$emailContent = str_replace("[[activateUrl]]", $verifyUrl, $emailContent);
		$logoImg = "<img src='http://qodort.com/logoemail.png'  />";
		
		
		
		
$message = '<html><body>';
$message .= '<center><img src="http://qodort.com/logoemail.png"  /></center>';
$message .= '<center><p>  شكرا لاشتراك بموقع مهارات وقدرات</p>';
//$message .= '<img src="http://qodort.com/logoemail.png" alt="Website Change Request" />';
$message .= '<table rules="all" style="border-color: #666;direction:rtl;" cellpadding="10">';
$message .= "<tr style='background: #eee;'><td><strong>الاسم:</strong> </td><td>" . strip_tags($name) . "</td></tr>";
$message .= "<tr><td><strong>الايميل:</strong> </td><td>" . strip_tags($userEmil) . "</td></tr>";
$message .= "<tr><td><strong>تفعيل الحساب:</strong> </td><td>" . "<a href=" . $verifyUrl . "> تفعيل الحساب </a>" . "</td></tr>";
$message .= "</table>";
$message .= '<p> بالتوفيق / فريق عمل قدرات</p></center>';

$message .= "</body></html>";
		
		
		
		$from_mail = $siteSettingsData -> email;

		sendEmailToUser($subject, $message, $userEmil, $from_mail);

	}

	public function forgetpass() {
		if (check_Front_logedin() == true)
			redirect(site_url("user/index"));

		$data['title'] = '';
		$data['ContentCenter'] = $this -> load -> view('site/user_forgetpass', $data, true);
		//$data['most_rate'] = $this -> posts_model -> GetMostRatedPosts();
		$this -> load -> view('site/main', $data);
	}

	public function changepass() {
		if (($this -> session -> userdata('front_uid') == ""))
			redirect(site_url("user/index"));

		$data['title'] = 'تغيير كلمة المرور';
		$data['form_action'] = site_url("user/changepass_submit");
		//$data['inner_content'] = $this -> load -> view('site/user_changepass', $data, true);
		$data['ContentCenter'] = $this -> load -> view('site/user_changepass', $data, true);
		$this -> load -> view('site/main', $data);

	}

	public function isOldPasswordTrue($password) {
		//$this -> load -> library('form_validation');
		//$this -> load -> model('user_model');

		$userId = get_Front_logedin_id();
		$is_exist = $this -> user_model -> isPasswordExist($password, $userId);

		if ($is_exist) {
			return true;
		} else {
			$this -> form_validation -> set_message('isOldPasswordTrue', ' كلمة السر الحالية غير صحيحة');

			return false;
		}
	}

	public function changepass_submit() {
		/*echo "<pre>";
		 var_dump($_POST);
		 die;*/

		$this -> load -> library('form_validation');
		// field name, error message, validation rules
		//$this -> form_validation -> set_rules('username', 'Username', 'trim|required|is_unique[users.username]');
		$this -> form_validation -> set_rules('current_password', ' كلمة المرور الحالية  ', 'trim|required|callback_isOldPasswordTrue');
		$this -> form_validation -> set_rules('password', 'كلمة المرور', 'trim|required|min_length[6]|max_length[32]');
		$this -> form_validation -> set_rules('password_confirm', ' تأكيد كلمة المرور  ', 'trim|required|matches[password]');

		$this -> form_validation -> set_message('min_length', '%s:  اقل عدد من الحروف هو  %s');

		$this -> form_validation -> set_message('required', ' %s   الرجاء ادخال ');
		$this -> form_validation -> set_message('matches', 'كلمات المرور غير متطابقة');

		if ($this -> form_validation -> run() == FALSE) {
			$this -> changepass();
		} else {

			$this -> user_model -> update_password();

			/*
			 $siteSettingsData = getTableDataRow("settings", array("id" => 1));
			 $from_mail = $siteSettingsData -> email;

			 $userIDD = get_Front_logedin_id();
			 $userExists = getTableDataRowFields("users", "email,full_name", array("user_id" => $userIDD));
			 $userEmail = $userExists -> email;
			 $first_name = $userExists -> full_name;

			 $newPass = $this -> input -> post('password');
			 //$userId = $this -> input -> post('user_id');

			 //$message = "Your new Sendsms Password is($newPass)";

			 $message = "
			 $first_name  \n
			 Your Account password  at Smart Saa Egypt Is Changed \n
			 Your New password is $newPass \n
			 Best Wishes \n
			 Smart SMS Egypt
			 ";

			 sendEmailToUser("SendSMS Password Changes", $message, $userEmail, $from_mail);
			 */
			set_user_msg(1, " تم تغيير كلمة المرور بنجاح");
			// ob_end_clean();

			/**********/

			$this -> index();
		}
	}

	public function update() {
		if (($this -> session -> userdata('front_uid') == ""))
			redirect(site_url("user/index"));

		$data['title'] = 'تعديل الملف الشخصى';
		$data['ContentCenter'] = $this -> load -> view('site/user_update', $data, true);
		//$data['most_rate'] = $this -> posts_model -> GetMostRatedPosts();
		$this -> load -> view('site/main', $data);

	}

	public function Mysubscription() {

		if (($this -> session -> userdata('front_uid') == "")) {
			set_user_msg(2, "  الرجاء تسجيل الدخول اولا");
			redirect(site_url("user/index"));
		}
		$userID = get_Front_logedin_id();
		$data['title'] = '      اشتراكاتي ودوراتي';
		$data['pg'] = "MYS";
		$data['MyCoursSubs'] = $this -> posts_model -> GetMysubscription($userID);

		$data['ContentCenter'] = $this -> load -> view('site/Mysubscriptions', $data, true);
		$this -> load -> view('site/main', $data);

	}

	public function MyApprovedSubscription() {

		if (($this -> session -> userdata('front_uid') == "")) {
			set_user_msg(2, "  الرجاء تسجيل الدخول اولا");
			redirect(site_url("user/index"));
		}
		$userID = get_Front_logedin_id();
		$data['title'] = '       دوراتي المؤكدة';
		$data['pg'] = "MYAS";
		$data['MyCoursSubs'] = $this -> posts_model -> GetMysubscription($userID, 1);

		$data['ContentCenter'] = $this -> load -> view('site/Mysubscriptions', $data, true);
		$this -> load -> view('site/main', $data);

	}

	public function submitRegisterInCourse($courseID = 0) {

		$course_Data = getTableDataRow("courses", array("id" => $courseID, "enabled" => 1));
		if ($course_Data == false) {
			set_user_msg(2, "  للاسف بيانات الكورس غير موجودة او الكورس معطل حاليا بواسطة الادارة");
			redirect(site_url("pages/index"));
			exit ;
		}

		// course_subscribers

		$postForm = $this -> input -> post();

		$postForm['created'] = date('Y-m-d H:i:s');
		$postForm['user_id'] = get_Front_logedin_id();
		$postForm['course_id'] = $courseID;

		$insertID = $this -> main_model -> insert('course_subscribers', $postForm);

		set_user_msg(1, " تم التسجيل فى الدورة بنجاح الرجاء الدفع لتفعيل الكورس ");
		$payMntType = $postForm['payment_type'];
		if ($payMntType == 1) {
			redirect('pages/bank_transfers');
		} else {
			redirect("pages/PayWithPayPal/{$insertID}");
		}

	}

	public function RegisterInCourse($courseID = 0) {
		if (($this -> session -> userdata('front_uid') == "")) {
			redirect(site_url("user/index"));
		}

		$data['title'] = 'التسجيل فى الدورة';
		$data['course_id'] = $courseID;
		$course_Data = getTableDataRow("courses", array("id" => $courseID, "enabled" => 1));
		if ($course_Data) {
			$data['course_Data'] = $course_Data;
		} else {
			set_user_msg(2, "  للاسف بيانات الكورس غير موجودة او الكورس معطل حاليا بواسطة الادارة");
			redirect(site_url("pages/index"));
			exit ;
		}

		$data['ContentCenter'] = $this -> load -> view('site/RegisterInCourse', $data, true);
		//$data['most_rate'] = $this -> posts_model -> GetMostRatedPosts();
		$this -> load -> view('site/main', $data);

	}

	public function subscriptions() {
		if (($this -> session -> userdata('front_uid') == ""))
			redirect(site_url("user/index"));

		$userID = get_Front_logedin_id();

		$data['title'] = 'الاشتراكات';
		$data['StoreSubscriptions'] = $this -> posts_model -> GetStoreSubscriptions($userID);
		$data['ContentCenter'] = $this -> load -> view('site/user_StoreSubscribtions', $data, true);
		//$data['most_rate'] = $this -> posts_model -> GetMostRatedPosts();
		$this -> load -> view('site/main', $data);

	}

	public function SavedCoupons() {
		if (($this -> session -> userdata('front_uid') == ""))
			redirect(site_url("user/index"));

		$userID = get_Front_logedin_id();

		$data['title'] = 'الكوبونات المحفوظة';
		$data['SavedCpns'] = $this -> posts_model -> GetSavedCoupons($userID);
		$data['ContentCenter'] = $this -> load -> view('site/user_SavedCoupons', $data, true);
		//$data['most_rate'] = $this -> posts_model -> GetMostRatedPosts();
		$this -> load -> view('site/main', $data);

	}

	public function FavouriteStoresCoupons() {
		if (($this -> session -> userdata('front_uid') == ""))
			redirect(site_url("user/index"));

		$userID = get_Front_logedin_id();

		$data['title'] = 'الكوبونات المفضلة';
		$data['favourtStrsCpns'] = $this -> posts_model -> GetFavouriteStoresCoupons($userID);
		$data['ContentCenter'] = $this -> load -> view('site/user_FavouriteStoresCoupons', $data, true);
		//$data['most_rate'] = $this -> posts_model -> GetMostRatedPosts();
		$this -> load -> view('site/main', $data);

	}

	public function AddFavouriteStores() {
		if (($this -> session -> userdata('front_uid') == ""))
			redirect(site_url("user/index"));

		$data['title'] = '';
		$data['ContentCenter'] = $this -> load -> view('site/user_AddFavouriteStores', $data, true);
		//$data['most_rate'] = $this -> posts_model -> GetMostRatedPosts();
		$this -> load -> view('site/main', $data);

	}

	public function update_submit() {

		$this -> load -> library('form_validation');
		// field name, error message, validation rules
		//$this -> form_validation -> set_rules('user_name', 'اسم المستخدم', 'trim|required|is_unique[users.user_name]');
		$this -> form_validation -> set_rules('full_name', 'الرجاء ادخال الاسم كاملا', 'trim|required|min_length[4]');

		$this -> form_validation -> set_rules('city', ' المدينة', 'trim|required|min_length[4]');
		$this -> form_validation -> set_rules('birth_date', '  تاريخ الميلاد', 'trim|required|min_length[8]');
		$this -> form_validation -> set_rules('phone', '    رقم الجوال', 'trim|required|callback_isPhoneExist');
		//$this -> form_validation -> set_rules('email', '  البريد   الالكترونى', 'trim|required|valid_email|is_unique[users.email]');
		//$this -> form_validation -> set_rules('password', 'كلمة المرور', 'trim|required|min_length[6]|max_length[32]');
		//$this -> form_validation -> set_rules('password_confirm', 'تأكيد كلمة المرور', 'trim|required|matches[password]');
		//	$this -> form_validation -> set_message('is_unique', "  اسم المستخدم  مسجل بالفعل");
		$this -> form_validation -> set_message('is_unique', ' %s   مسجل بالفعل');
		$this -> form_validation -> set_message('min_length', '%s:  اقل عدد من الحروف هو  %s');

		$this -> form_validation -> set_message('required', ' %s   الرجاء ادخال ');
		//$this -> form_validation -> set_message('matches', 'كلمات المرور غير متطابقة');

		if ($this -> form_validation -> run() == FALSE) {
			$this -> update();
		} else {

			$this -> user_model -> update_user();
			set_user_msg(1, " تم التحديث بنجاح");

			$this -> update();

		}

	}

	public function isEmailExist($email) {
		//$this -> load -> library('form_validation');
		//$this -> load -> model('user_model');

		$userId = $this -> input -> post("user_id");
		$is_exist = $this -> user_model -> isEmailExist($email, $userId);

		if ($is_exist) {
			$this -> form_validation -> set_message('isEmailExist', 'الإيميل مسجل بالفعل');
			return false;
		} else {
			return true;
		}
	}

	public function isPhoneExist($phone) {
		//$this -> load -> library('form_validation');
		//$this -> load -> model('user_model');

		$userId = get_Front_logedin_id();
		$is_exist = $this -> user_model -> isPhoneExist($phone, $userId);

		if ($is_exist) {
			$this -> form_validation -> set_message('isPhoneExist', 'الجوال  مسجل بالفعل');
			return false;
		} else {
			return true;
		}
	}

	/*
	 public function changepass_submit() {

	 $this -> load -> library('form_validation');
	 // field name, error message, validation rules
	 //$this -> form_validation -> set_rules('username', 'Username', 'trim|required|is_unique[users.username]');
	 $this -> form_validation -> set_rules('display_name', 'Display name', 'trim|required|min_length[4]');
	 $this -> form_validation -> set_rules('phone', 'Phone', 'trim|required|min_length[4]');
	 $this -> form_validation -> set_rules('email', 'Your Email', 'trim|required|valid_email|is_unique[users.email]');
	 $this -> form_validation -> set_rules('password', 'Password', 'trim|required|min_length[6]|max_length[32]');
	 $this -> form_validation -> set_rules('password_confirm', 'Password Confirmation', 'trim|required|matches[password]');
	 $this -> form_validation -> set_message('is_unique', 'The %s  is already Exists');

	 if ($this -> form_validation -> run() == FALSE) {
	 $this -> register();
	 } else {

	 $this -> user_model -> add_user();
	 $this -> login();
	 }
	 }
	 */
	public function welcome() {

		// $userIDD = get_Front_logedin_id();

		// redirect(site_url("pages/users/$userIDD"));

		$data['title'] = 'حسابي';
		$data['ContentCenter'] = $this -> load -> view('site/user_welcome', $data, true);
		//$data['most_rate'] = $this -> posts_model -> GetMostRatedPosts();
		$this -> load -> view('site/main', $data);
	}

	public function login() {

		if (($this -> session -> userdata('front_uid') != ""))
			redirect(site_url("user/index"));

		$data['title'] = '';
		$data['ContentCenter'] = $this -> load -> view('site/user_login', $data, true);
		//$data['most_rate'] = $this -> posts_model -> GetMostRatedPosts();
		$this -> load -> view('site/main', $data);
	}
	public function QuizUserRelate($email, $password,$name=" "){
		
		$userData = getTableDataRow("savsoft_users",array("email"=>$email));
		if($userData){
			 $this -> main_model -> update('savsoft_users', array("password"=>md5($password)),array("email"=>$email));
			
		}else{
			 $this -> main_model -> insert('savsoft_users', array("password"=>md5($password),"email"=>$email,'first_name'=>$name,'registered_date'=>time()));
			
			
		}
		
	}

	public function login_submit() {
		$email = $this -> input -> post('email');
		//$username = $this -> input -> post('username');

		$password = $this -> input -> post('password');

		$result = $this -> user_model -> login($email, $password);
		if ($result) {

			//$userIDD = get_Front_logedin_id();
			$this->QuizUserRelate($email, $password);

			redirect(site_url("user/index"));

		}

		//$this -> welcome();
		else {

			redirect(site_url('user/login'));
		}

		//$this -> login();
	}

	public function callback_isuserNameExist($username) {
		$this -> load -> library('form_validation');
		//$this -> load -> model('user');
		$is_exist = $this -> user_model -> isUserNameExist($username);

		if ($is_exist) {
			$this -> form_validation -> set_message('isUserNameExist', 'UserName address is already exist.');
			return false;
		} else {
			return true;
		}
	}

	public function logout() {
		$newdata = array('front_uid' => '', 'front_username' => '', 'front_email' => '', 'front_Login' => FALSE, );
		//-$newdata = array('user_id' => '', 'user_name' => '', 'user_email' => '', 'logged_in' => FALSE, );
		$this -> session -> unset_userdata($newdata);
		//-$this -> session -> sess_destroy();
		set_user_msg(1, " تم تسجيل الخروج بنجاح");

		$this -> index();
	}

}
?>