<?php

/*
  MySQL database backup class, version 1.0.0
  Written by Vagharshak Tozalakyan <vagh@armdex.com>
  Released under GNU Public license
*/


define('MSB_VERSION', '1.0.0');

define('MSB_NL', "\r\n");

define('MSB_STRING', 0);
define('MSB_DOWNLOAD', 1);
define('MSB_SAVE', 2);

class mysql_backup
{

  var $server = 'localhost';
  var $port = 3306;
  var $username = 'root';
  var $password = 'tawasol!t';
  var $database = 'Hajji';
  var $link_id = -1;
  var $connected = false;
  var $tables = array();
  var $drop_tables = false;
  var $struct_only = false;
  var $create_tables = FALSE;
  var $comments = false;
  var $backup_dir = '';
  var $fname_format = 'd_m_y__H_i';
  var $error = '';
  
  function Execute($task = MSB_STRING, $fname = '', $compress = false)
  {
    if (!($sql = $this->_Retrieve()))
    {
      return false;
    }
    if ($task == MSB_SAVE)
    {
      if (empty($fname))
      {
        $fname = $this->backup_dir;
        $fname .= date($this->fname_format);
        $fname .= ($compress ? '.sql.gz' : '.sql');
      }
      return $this->_SaveToFile($fname, $sql, $compress);
    }
    elseif ($task == MSB_DOWNLOAD)
    {
      if (empty($fname))
      {
        $fname = date($this->fname_format);
        $fname .= ($compress ? '.sql.gz' : '.sql');
      }
      return $this->_DownloadFile($fname, $sql, $compress);
    }
    else
    {
      return $sql;
    }
  }


  function _Connect()
  {
    $value = false;
    if (!$this->connected)
    {
      $host = $this->server . ':' . $this->port;
      $this->link_id = mysql_connect($host, $this->username, $this->password);
    }
    if ($this->link_id)
    {
      if (empty($this->database))
      {
        $value = true;
      }
      elseif ($this->link_id !== -1)
      {
        $value = mysql_select_db($this->database, $this->link_id);
      }
      else
      {
        $value = mysql_select_db($this->database);
      }
	  mysql_query("set names utf8");
    }
    if (!$value)
    {
      $this->error = mysql_error();
    }
    return $value;
  }


  function _Query($sql)
  {
    if ($this->link_id !== -1)
    {
      $result = mysql_query($sql, $this->link_id);
    }
    else
    {
      $result = mysql_query($sql);
    }
    if (!$result)
    {
      $this->error = mysql_error();
    }
    return $result;
  }


  function _GetTables()
  {
    $value = array();
    if (!($result = $this->_Query('SHOW TABLES')))
    {
      return false;
    }
    while ($row = mysql_fetch_row($result))
    {
      if (empty($this->tables) || in_array($row[0], $this->tables))
      {
        $value[] = $row[0];
      }
    }
    if (!sizeof($value))
    {
      $this->error = 'No tables found in database.';
      return false;
    }
    return $value;
  }


  function _DumpTable($table)
  {
    $value = '';
    //$this->_Query('LOCK TABLES ' . $table . ' WRITE');
    if ($this->comments)
    {
      $value .= '#' . MSB_NL;
      $value .= '# Table structure for table `' . $table . '`' . MSB_NL;
      $value .= '#' . MSB_NL . MSB_NL;
    }
    if ($this->drop_tables)
    {
      $value .= 'DROP TABLE IF EXISTS `' . $table . '`;' . MSB_NL;
    }
    if (!($result = $this->_Query('SHOW CREATE TABLE ' . $table)))
    {
      return false;
    }
    $row = mysql_fetch_assoc($result);
	
	if ($this->create_tables)
	{
    	$value .= str_replace("\n", MSB_NL, $row['Create Table']) . ';';
    	$value .= MSB_NL . MSB_NL;
    }
    if (!$this->struct_only)
    {
      if ($this->comments)
      {
        $value .= '#' . MSB_NL;
        $value .= '# Dumping data for table `' . $table . '`' . MSB_NL;
        $value .= '#' . MSB_NL . MSB_NL;
      }
      $value .= $this->_GetInserts($table);
    }
    $value .= MSB_NL . MSB_NL;
    //$this->_Query('UNLOCK TABLES');
    return $value;
  }


  function _GetInserts($table)
  {
    $value = '';
if($table == "groups")
	{
		if (!($result = $this->_Query("SELECT `group_id`, `name` FROM `groups` WHERE 1")))
		{
			return false;
		}
	}
	
	elseif($table == "notifications")
	{
		if (!($result = $this->_Query("SELECT `notification_id`, `message`, `date`, `time` FROM `notifications` WHERE 1")))
		{
			return false;
		}
	}	
	elseif($table == "pilgrims")
	{
		if (!($result = $this->_Query("SELECT `pilgrim_id`, `name`, `photo`,'latitude','longitude' FROM `pilgrims` WHERE 1")))
		{
			return false;
		}
	}
	elseif($table == "tour_guides")
	{
		if (!($result = $this->_Query("SELECT `tour_guide_id`, `name`, `photo`,'latitude','longitude' FROM `tour_guides` WHERE 1")))
		{
			return false;
		}
	}
	else{
		if (!($result = $this->_Query('SELECT * FROM ' . $table)))
	    {
	      return false;
	    }
	}
	
	while ($row = mysql_fetch_row($result))
    {
      $values = '';
      foreach ($row as $data)
      {
        $values .= '\'' . str_replace("'","''",$data) . '\', ';
      }
      $values = substr($values, 0, -2);
      $value .= 'INSERT INTO ' . $table . ' VALUES (' . $values . ');' . MSB_NL;
    }
    return $value;
  }


  function _Retrieve()
  {
    $value = '';
    if (!$this->_Connect())
    {
      return false;
    }
    if ($this->comments)
    {
      $value .= '#' . MSB_NL;
      $value .= '# MySQL database dump' . MSB_NL;
      $value .= '# Created by MySQL_Backup class, ver. ' . MSB_VERSION . MSB_NL;
      $value .= '#' . MSB_NL;
      $value .= '# Host: ' . $this->server . MSB_NL;
      $value .= '# Generated: ' . date('M j, Y') . ' at ' . date('H:i') . MSB_NL;
      $value .= '# MySQL version: ' . mysql_get_server_info() . MSB_NL;
      $value .= '# PHP version: ' . phpversion() . MSB_NL;
      if (!empty($this->database))
      {
        $value .= '#' . MSB_NL;
        $value .= '# Database: `' . $this->database . '`' . MSB_NL;
      }
      $value .= '#' . MSB_NL . MSB_NL . MSB_NL;
    }
    if (!($tables = $this->_GetTables()))
    {
      return false;
    }
    foreach ($tables as $table)
    {
      if (!($table_dump = $this->_DumpTable($table)))
      {
        $this->error = mysql_error();
        return false;
      }
      $value .= $table_dump;
    }
    return $value;
  }


  function _SaveToFile($fname, $sql, $compress)
  {
    if ($compress)
    {
      if (!($zf = gzopen($fname, 'w9')))
      {
        $this->error = 'Can\'t create the output file.';
        return false;
      }
      gzwrite($zf, $sql);
      gzclose($zf);
    }
    else
    {
      if (!($f = fopen($fname, 'w')))
      {
        $this->error = 'Can\'t create the output file.';
        return false;
      }
      fwrite($f, $sql);
      fclose($f);
	  
	  $this->create_zip(array($fname),'db.zip');
    }
    return true;
  }


  function _DownloadFile($fname, $sql, $compress)
  {
    header('Content-disposition: filename=' . $fname);
    header('Content-type: application/octetstream');
    header('Pragma: no-cache');
    header('Expires: 0');
    echo ($compress ? gzencode($sql) : $sql);
    return true;
  }

	function create_zip($files = array(),$destination = '',$overwrite = true) {
	if(extension_loaded('zip')){
	echo "Y";
	}
	else{
	echo "no";
	}
		$dir="third_party/db/";
		  //if the zip file already exists and overwrite is false, return false
		  if(file_exists($dir.$destination) && !$overwrite) { return false; }
		  //vars
		  $valid_files = array();
		  //if files were passed in...
		  if(is_array($files)) {
		    //cycle through each file
		    foreach($files as $file) {
		      //make sure the file exists
		      if(file_exists($dir.$file)) {
		        $valid_files[] = $file;
		      }
		    }
		  }
		  //if we have good files...
		  if(count($valid_files)) {
		    //create the archive
			
		    $zip = new ZipArchive();
			echo "cc";
		    if($zip->open($dir.$destination,$overwrite ? ZIPARCHIVE::OVERWRITE : ZIPARCHIVE::CREATE) !== true) {
		      echo "vv";
			  return false;
			  
		    }
			
		    //add the files
		    foreach($valid_files as $file) {
			
		      $zip->addFile($dir.$file,$file);
			  
		    }
		    //debug
		    //echo 'The zip archive contains ',$zip->numFiles,' files with a status of ',$zip->status;
		    
		    //close the zip -- done!
		    $zip->close();
		    
		    //check to make sure the file exists
		    return file_exists($dir.$destination);
		  }
		  else
		  {
		    return false;
		  }
	}
}

?>